Attribute VB_Name = "modSettings"
'HuntERR Add-In, version 1.0, 07/06/2001
'URFIN JUS (www.urfinjus.net)
'Add-In settings
Option Explicit
Private Const APP_NAME = "HuntERRAddIn"
Private Const SECTION = "Settings"

Public SttModuleName As String, SttAskConfirmation As Boolean
Public SttAddStopOnError As Boolean
Public SttUseEAexternCall As Boolean, SttUseEAinternCall As Boolean
Public SttConstEAexternCall As String, SttConstEAinternCall As String, SttErrResProc As String
Public SttDeleteOld As Boolean, SttSimplePropNo As Boolean
Public SttLastSavedUndoModule As String

Public Sub SettingsLoad()
    On Error GoTo errHandler
    SttModuleName = ""
    SttAddStopOnError = boolGetStt("AddStopOnError")
    SttAskConfirmation = boolGetStt("AskConfirmation")
    SttUseEAexternCall = boolGetStt("UseEAExternCall")
    SttUseEAinternCall = boolGetStt("UseEAInternCall")
    SttConstEAexternCall = GetStt("ConstEAExternCall")
    SttConstEAinternCall = GetStt("ConstEAInternCall")
    SttErrResProc = GetStt("ErrorHandlerProc")
    SttDeleteOld = boolGetStt("DeleteOld")
    SttSimplePropNo = boolGetStt("SimplePropNo")
    SttLastSavedUndoModule = ""
    Exit Sub
errHandler:
    ErrorIn "SettingsLoad"
End Sub

Public Sub SettingsSave()
    On Error GoTo errHandler
    boolSaveStt "AddStopOnError", SttAddStopOnError
    boolSaveStt "AskConfirmation", SttAskConfirmation
    boolSaveStt "UseEAExternCall", SttUseEAexternCall
    boolSaveStt "UseEAInternCall", SttUseEAinternCall
    SaveStt "ConstEAExternCall", SttConstEAexternCall
    SaveStt "ConstEAInternCall", SttConstEAinternCall
    SaveStt "ErrorHandlerProc", SttErrResProc
    boolSaveStt "DeleteOld", SttDeleteOld
    boolSaveStt "SimplePropNo", SttSimplePropNo
    Exit Sub
errHandler:
    ErrorIn "modSettings.SettingsSave"
End Sub

Public Function GetStt(ByVal SttName As String) As String
    On Error GoTo errHandler
    GetStt = GetSetting(APP_NAME, SECTION, SttName)
    Exit Function
errHandler:
    ErrorIn "modSettings.GetStt(SttName)", SttName
End Function

Public Function boolGetStt(ByVal SttName As String) As Boolean
    boolGetStt = SafeBool(GetStt(SttName))
End Function

Public Function SaveStt(ByVal SttName As String, ByVal Value As String)
    On Error GoTo errHandler
    SaveSetting APP_NAME, SECTION, SttName, Value
    Exit Function
errHandler:
    ErrorIn "modSettings.SaveStt(SttName,Value)", Array(SttName, Value)
End Function

Public Function boolSaveStt(ByVal SttName As String, ByVal Value As Boolean)
    SaveStt SttName, CStr(Value)
End Function

Public Function SafeBool(ByVal V) As Boolean
    On Error Resume Next
    SafeBool = CBool(V)
End Function

