VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 4  'RequiresNewTransaction
END
Attribute VB_Name = "ujTransaction"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'========================================================================================
'ujTransaction
'COM+ Transaction Control Class
'by URFIN JUS (www.urfinjus.net)
'=========================================================================================
' Description:   A simple class controlling transactions in COM+.
' Dependencies:  COM+ Services type library
' Comments:     This class should have MTSTransactionMode property set to RequiresNewTransaction.
'               Application creates ujTransaction instance to start COM+ transaction.
'               Then it should create database class instances it wants to participate
'               in transaction using CreateInstance method.
'               Then application calls database class methods performing database operations.
'               Lastly, transaction is commited by calling SetComplete method of ujTransaction.
'               In case of error transaction is aborted through SetAbort method of ujTransaction.

'Public members
'Public Function CreateInstance(ByVal ProgID As String) As Object
'Public Sub SetComplete()    
'Public Sub SetAbort()

Option Explicit

Public Function CreateInstance(ByVal ProgID As String) As Object
    On Error GoTo errHandler
    Set CreateInstance = CreateObject(ProgID)
    Exit Function
errHandler:
    Err.Raise Err.Number, Err.Source, Err.Description & _
        ": ujTransaction.CreateInstance('" & ProgID & "')"
End Function

Public Sub SetComplete()
    'No error protection - catch it in the caller
    GetObjectContext.SetComplete
End Sub


Public Sub SetAbort()
    On Error Resume Next 'Protect from failure if called from error handler
    GetObjectContext.SetAbort
End Sub

